package hu.elte.teszteszkozok.gyak3.tankos.egysegek;

import java.util.Date;

public abstract class HarciEgyseg implements Harcolo, EletCiklus {

    private static int idGen;
    private final int id;
    protected float elet;
    protected float sebzes;
    protected float pancel;

    public HarciEgyseg(float elet, float sebzes, float pancel) {
        this.elet = elet;
        this.sebzes = sebzes;
        this.pancel = pancel;
        this.id = idGen++;
    }

    @Override
    public void tamad(Harcolo harcolo) {
        log(this + " megtamadja " + harcolo + "-t");
        harcolo.sebzodik(sebzes);
    }

    @Override
    public void sebzodik(float sebzesPont) {
        if (pancel > 0f) {
            pancel -= sebzesPont / 2;

            if (pancel < 0.001f) {
                sebzesPont = -pancel * 2;
                log(this + " elvesztette a panceljat.");
                pancel = 0f;
            }

            if (pancel > 0) {
                sebzesPont = 0f;
            }
        }

        elet -= sebzesPont;
        if (elet < 0.001f) {
            elet = 0f;
            log(this + " meghalt a csatamezon. :(");
        }
    }

    @Override
    public boolean elo() {
        return elet >= 0.001f;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + '{' + id + '}';
    }

    protected void log(String uzenet) {
        System.out.println(new Date() + " " + uzenet);
    }

}
