package hu.elte.teszteszkozok.gyak3.stack;

import junit.framework.Assert;
import org.junit.Test;

public class StackTest {

    @Test
    public void testConstruct() {
        Stack<String> stack = new Stack<>(10);

        Assert.assertNotNull(stack);
        Assert.assertFalse(stack.isFull());
        Assert.assertTrue(stack.isEmpty());
    }

    @Test
    public void testPopShouldReturnTopElementWhenStackIsNonEmpty() throws StackOverflowException, StackEmptyException {
        // GIVEN
        Stack<String> stack = new Stack<>(4);
        stack.push("elefánt");
        stack.push("béka");

        String expectedElement = "béka";

        // WHEN
        String result = stack.pop();

        // THEN
        Assert.assertEquals(expectedElement, result);
    }

    @Test(expected = StackEmptyException.class)
    public void testPopShouldReturnTopElementWhenStackIsEmpty() throws StackEmptyException {
        // GIVEN
        Stack<String> stack = new Stack<>(4);

        // WHEN
        stack.pop();
    }
}
